#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# +-------------------------------------------------------------------
# | Copyright (c) 2015-2099 宝塔软件(http://bt.cn) All rights reserved.
# +-------------------------------------------------------------------
# | Author: xxx <xxxx@qq.com>
# +-------------------------------------------------------------------

#+--------------------------------------------------------------------
#|   宝塔第三方应用开发hash_pk
#+--------------------------------------------------------------------
import sys,os,json,hashlib,time,ast

#设置运行目录
os.chdir("/www/server/panel")

#添加包引用位置并引用公共包
sys.path.append("class/")
import public
import send_mail
#from common import dict_obj
#get = dict_obj();


#在非命令行模式下引用面板缓存和session对象
if __name__ != '__main__':
    from BTPanel import cache,session,redirect

    #设置缓存(超时10秒) cache.set('key',value,10)
    #获取缓存 cache.get('key')
    #删除缓存 cache.delete('key')

    #设置session:  session['key'] = value
    #获取session:  value = session['key']
    #删除session:  del(session['key'])
class hash_pk_main:
    __config = None
    __plugin_path = "/www/server/panel/plugin/hash_pk/"
    __path = '/www/server/panel/backup/hash_pk'
    __logs = '/www/wwwlogs/hash_pk'
    __mail_config = '/www/server/panel/data/stmp_mail.json'
    __mail_list_data = '/www/server/panel/data/mail_list.json'
    __dingding_config = '/www/server/panel/data/dingding.json'
    __time_out = time.strftime('%Y%m%d_%H%M%S',time.localtime())
    __paths=''
    __files_dict={}
    __mail_list = []
    __weixin_user = []

    #构造方法
    def  __init__(self):
        self.mail = send_mail.send_mail()
        if not os.path.exists(self.__path):
            os.system('mkdir -p ' + self.__path)
            os.system('chmod -R 600 %s' % self.__path)
        if not os.path.exists(self.__logs):
            os.system('mkdir -p ' + self.__logs)
            os.system('chmod -R 600 %s' % self.__logs)

    # 查看宝塔存在哪些站点
    def get_sites(self,get):
        if not 'p' in get: get.p = 1
        if not 'rows' in get: get.rows = 12
        if not 'callback' in get: get.callback = ''
        get.p = int(get.p)
        get.rows = int(get.rows)
        count = public.M('sites').count()
        page_data = public.get_page(count,get.p,get.rows,get.callback)
        site_list = public.M('sites').order('id desc').limit(page_data['shift'] + ',' + page_data['row']).field('id,name,path').select()
        return {'data': site_list,'page':page_data['page'] }

    # 查看hash文件
    def GetList(self, get):
        clearPath = [{'path': '/www/server/panel/backup/hash_pk/', 'find': '.hash'}]
        total = count = 0
        ret = []
        for c in clearPath:
            c['path']=c['path']+get.sitename
            if os.path.exists(c['path']):
                for d in os.listdir(c['path']):
                    print(c)
                    if d.find('.hash') == -1: continue
                    filename = c['path'] + '/' + d
                    # print(filename)
                    fsize = os.path.getsize(filename)
                    ret_size = {}
                    ret_size['name'] = filename
                    ret_size['sitename'] = get.sitename
                    time1 = os.path.getmtime(filename)
                    # c2 = time.localtime(time1)
                    ret_size['time'] = int(time1)
                    ret_size['filename'] = os.path.basename(filename)
                    ret_size['download'] = '/download?filename=' + filename
                    ret_size['size'] = self.ToSize(int(fsize))
                    ret.append(ret_size)

        ret = sorted(ret,key=lambda x:x['time'],reverse=True)
        return ret

    # 查看站点包进行效验
    def hash_main(self,get):
        clearPath = [{'path': '/www/server/panel/backup/hash_pk/', 'find': '.hash'}]
        total = count = 0
        ret = []
        dict2={}
        hastype=int(get.type)
        sitename=get.sitename
        site_hash=get.site_hash
        for c in clearPath:
            c['path']=c['path']+sitename
            if os.path.exists(c['path']):
                for d in os.listdir(c['path']):
                    print(c)
                    if d.find('.hash') == -1: continue
                    filename = c['path'] + '/' + d
                    # print(filename)
                    fsize = os.path.getsize(filename)
                    ret_size = {}
                    time1 = os.path.getmtime(filename)
                    # c2 = time.localtime(time1)
                    ret_size['time'] = int(time1)
                    ret_size['filename'] = os.path.basename(filename)
                    ret.append(ret_size)
        ret = sorted(ret,key=lambda x:x['time'],reverse=True)
        if hastype == 1:
            self.files_hash(sitename,site_hash)
        lfilename=self.__logs+'/'+sitename+'.log'
        if os.path.exists(lfilename):
            str_dict= public.ReadFile(lfilename,mode='r')
            dict2=ast.literal_eval(str_dict)
            if self.__get_config()['status']=='true':
                dict2['edit']=self.filter_file(dict2['edit'])
                dict2['add']=self.filter_file(dict2['add'])
                dict2['del']=self.filter_file(dict2['del'])
            dict2['hashlist']=ret
            file_path = public.M('sites').where('name=?',sitename).getField('path')
            dict2['path']=file_path
        dict2['hashlist']=ret
        return dict2

    # 查找站点编码目录生成hash包存放
    def get_hash(self,get):
        sitename = get.sitename
        file_path = public.M('sites').where('name=?',sitename).getField('path')
        #file_path='/www/web/default'
        f_body=str(self.get_list(file_path))
        f_path=self.__path+'/'+sitename
        filename=f_path+'/'+sitename+self.__time_out+'.hash'
        #return {'0':self.__paths,'1':f_path,'2':filename,'3':f_body}
        if not os.path.exists(f_path):
            os.system('mkdir -p ' + f_path)
            os.system('chmod -R 600 %s' % f_path)
        public.WriteFile(filename,f_body,mode='w+')
        return public.returnMsg(True, "创建成功")

    # 获取目录生成的hash包
    def get_list(self,path):
        self.__paths=path
        self.__files_dict={}
        self.files(path)
        return self.__files_dict

    #  查看新增内容
    def list_pk(self,list1,list2):
        key_list=[]
        for row in  list1:
            if not row in list2:
                key_list.append(row)
        return key_list

    # 比较两个hash包
    def hash_pk(self,dict1,dict2):#目标dict1 模板dict2
        # key_list=dict.keys()
        data={}
        key_list=[]
        key_list1=dict1.keys()
        key_list2=dict2.keys()
        # 新增keyprint('新增')print(self.list_pk(key_list1,key_list2))
        data['date']=time.strftime('%Y%m%d_%H%M%S',time.localtime())
        data['add']=self.list_pk(key_list1,key_list2)
        # 被篡改相同key不同值。
        for row in key_list2:
            try:
                if dict1[row] == dict2[row] :
                    continue
                else:
                    key_list.append(row)
            except:
                continue
        # print('修改过')print(key_list)
        data['edit']=key_list
        # 被删除的keyprint('减少')print(self.list_pk(key_list2,key_list1))
        data['del']=self.list_pk(key_list2,key_list1)
        return data

    def files_main(self,get):
        if get.type=="0":
            path1=get.path1
            path2=get.path2
            self.files_path(path1,path2)
        lfilename=self.__logs+'/files_main.log'
        if os.path.exists(lfilename):
            str_dict= public.ReadFile(lfilename,mode='r')
            dict=ast.literal_eval(str_dict)
            if self.__get_config()['status']=='true':
                dict['edit']=self.filter_file(dict2['edit'])
                dict['add']=self.filter_file(dict2['add'])
                dict['del']=self.filter_file(dict2['del'])
        return dict

    # 对比两个文件路路径
    def files_path(self,path1,path2):#目标path1 参考path2
        dict1=self.get_list(path1)  #目标
        dict2=self.get_list(path2)  #参考
        data=self.hash_pk(dict1,dict2)
        data['path1']=path1
        data['path2']=path2
        lfilename=self.__logs+'/files_main.log'
        if os.path.exists(lfilename):
            os.system('rm -rf %s' % lfilename)
        str_dict=str(data)
        public.WriteFile(lfilename,str_dict,mode='w+')

    # 对比站点hash
    def files_hash(self,sitename,site_hash):
        file_path = public.M('sites').where('name=?',sitename).getField('path')
        dict1=self.get_list(file_path)# 获取站点当前hash
        f_path=self.__path+'/'+sitename
        filename=f_path+'/'+site_hash
        str_dict= public.ReadFile(filename,mode='r')
        dict2=ast.literal_eval(str_dict)
        data=self.hash_pk(dict1,dict2)
        lfilename=self.__logs+'/'+sitename+'.log'
        if os.path.exists(lfilename):
            os.system('rm -rf %s' % lfilename)
        str_dict=str(data)
        public.WriteFile(lfilename,str_dict,mode='w+')

    # 文件目录过滤设置
    def set_filter_file(self,get):
        if get.type =='0':
            self.__set_config('file',get.file)
            self.__set_config('dir',get.dir)
            self.__set_config('status',get.status)
        config=self.__get_config()
        return config
    def Monit_task(self,get):
        data={}
        try:
            data['hash_list']=self.GetList(get)
        except:
            data['site_list'] = public.M('sites').order('id desc').field('id,name,path').select()
        return data

    def add_task(self):
        pass
    def del_task(self):
        pass
    def edit_task(self):
        pass
    # 文件目录后缀过滤
    def filter_file_send(self,data,files,dirs):
        try:
            res=[]
            for row in data:
                flag=1
                for dir in dirs:
                    if not dir in row or dir =='':
                        continue
                    else:
                        flag=0
                for file in files:
                    if not file in row or file =='':
                        continue
                    else:
                        flag=0
                if flag==1:
                	res.append(row)
        except:
            res=data
        return res
    # 文件目录后缀过滤
    def filter_file(self,data):
        try:
            res=[]
            for row in data:
                flag=1
                for dir in self.__get_config()['dir'].strip('|').split("|"):
                    if not dir in row or dir =='':
                        continue
                    else:
                        flag=0
                for file in self.__get_config()['file'].strip('|').split("|"):
                    if not file in row or file =='':
                        continue
                    else:
                        flag=0
                if flag==1:
                	res.append(row)
        except:
            res=data
        return res
    # 返回配置邮件地址
    def return_mail_list(self):
        return self.__mail_list

    # 查看自定义邮箱配置
    def get_user_mail(self):
        qq_mail_info = json.loads(public.ReadFile(self.__mail_config))
        if len(qq_mail_info) == 0:
            return False
        return qq_mail_info

    # 查看钉钉
    def get_dingding(self):
        qq_mail_info = json.loads(public.ReadFile(self.__dingding_config))
        if len(qq_mail_info) == 0:
            return False
        return qq_mail_info
     # 查看能使用的告警通道
    def get_settings(self):
        qq_mail_info = json.loads(public.ReadFile(self.__mail_config))
        if len(qq_mail_info) == 0:
            user_mail = False
        else:
            user_mail = True
        dingding_info = json.loads(public.ReadFile(self.__dingding_config))
        if len(dingding_info) == 0:
            dingding = False
        else:
            dingding = True
        ret = {}
        ret['user_mail'] = {"user_name": user_mail, "mail_list": self.__mail_list, "info": self.get_user_mail()}
        ret['dingding'] = {"dingding": dingding, "info": self.get_dingding()}
        return ret

    def sendmsghtml(self,sitename,data):
        addlist=''
        editlist=''
        dellist=''
        for row in data['add']:
            addlist+="""<li><span style="font-family: 'Microsoft Yahei';">{}</span></li>""".format(row)
        for row in data['edit']:
            editlist+="""<li><span style="font-family: 'Microsoft Yahei';">{}</span></li>""".format(row)
        for row in data['del']:
            dellist+="""<li><span style="font-family: 'Microsoft Yahei';">{}</span></li>""".format(row)
        msg="""
        <div>
   <div style="margin:0;">
    <span style="font-family: 'Microsoft Yahei';"><span style="font-size: 24px;">文件效验监测到站点</span><span style="font-size: 24px; line-height: 40.8px;">【</span><span style="font-size: 24px; line-height: 40.8px; color: rgb(221, 64, 50); background-color: rgb(255, 255, 255);">{}</span><span style="font-size: 24px; line-height: 40.8px;">】</span><span style="font-size: 24px; line-height: 1.7;">存在文件异常：</span></span>
   </div>
   <div style="margin:0;">
    <span style="font-size: 24px; line-height: 1.7; font-family: 'Microsoft Yahei';"><br /></span>
   </div>
   <div style="margin:0;">
    <span style="font-size: 24px; line-height: 40.8px; font-family: 'Microsoft Yahei';">增加文件：</span>
   </div>
   <div style="margin:0;">
    <div>
     <ol>
      {}
     </ol>
    </div>
    <div>
     <span style="font-size: 24px; line-height: 40.8px; font-family: 'Microsoft Yahei';">修改文件：</span>
    </div>
    <div>
     <ol>
    {}
     </ol>
    </div>
    <div>
     <span style="font-size: 24px; line-height: 40.8px; font-family: 'Microsoft Yahei';">删除文件：</span>
    </div>
    <div>
     <ol>
     {}
     </ol>
    </div>
    <div>
     <span style="font-size: 24px; line-height: 40.8px;"><br /></span>
    </div>
   </div>
   <br />
  </div>
        """.format(sitename,addlist,editlist,dellist)
        return msg


    def send_san_dir(self, path,files,dirs,send):
        data=ast.literal_eval(public.ReadFile(self.__logs+'/'+path+'.log',mode='r'))
            # if self.__get_config()['status']=='true':
            #     dict2['edit']=self.filter_file(dict2['edit'])
            #     dict2['add']=self.filter_file(dict2['add'])
            #     dict2['del']=self.filter_file(dict2['del'])
            # dict2['hashlist']=ret
            # file_path = public.M('sites').where('name=?',sitename).getField('path')
            # dict2['path']=file_path
        data['edit']=self.filter_file_send(data['edit'],files,dirs)
        data['add']=self.filter_file_send(data['add'],files,dirs)
        data['del']=self.filter_file_send(data['del'],files,dirs)
        return_data=data
        tongdao = self.get_settings()
        if len(data['add']) >= 1 or len(data['del']) >= 1 or len(data['edit']) >= 1:
            sendmsg=self.sendmsghtml(path,return_data)
            if send == 'dingding':
                if tongdao['dingding']:
                    msg = sendmsg#"文件效验发现%s目录中存在问题如下:%s" % (path, return_data)
                    self.mail.dingding_send(msg)
            elif send == 'mail':
                if tongdao['user_mail']:
                    title = "文件效验发现%s目录中存在问题如下" % (path)
                    body = sendmsg #"文件效验发现%s目录中存在问题如下:%s" % (path, return_data)
                    if len(self.__mail_list) == 0:
                        self.mail.qq_smtp_send(str(tongdao['user_mail']['info']['qq_mail']), title=title, body=body)
                    else:
                        for i in self.__mail_list:
                            self.mail.qq_smtp_send(str(i), title=title, body=body)
        return return_data

    # 遍历目录生成hash字典
    def files(self,path):
        file_list=os.listdir(path)
        for flie in file_list:
            file_path=os.path.join(path,flie)
            if os.path.isdir(file_path):
                self.files(file_path)
            else:
                self.__files_dict[file_path.replace(self.__paths,"")]=self.GetFileMd5(file_path)
    # 生成MD5哈希
    def GetFileMd5(self,filename):
        return public.FileMd5(filename)
    # 删除hash文件
    def DelFile(self, get):
        path = get.sitename+'/'+get.filename
        name_path = self.__path +'/'+path.replace('..','')
        if os.path.exists(name_path):
            os.system('rm -rf %s' % name_path)
        return public.returnMsg(True, "删除成功")
    # 字节单位转换
    def ToSize(self, size):
        ds = ['b', 'KB', 'MB', 'GB', 'TB']
        for d in ds:
            if int(size) < 1024: return "%.2f%s" % (size , d)
            size = size / 1024
        return '0b'

    #读取配置项(插件自身的配置文件)
    #@param key 取指定配置项，若不传则取所有配置[可选]
    #@param force 强制从文件重新读取配置项[可选]
    def __get_config(self,key=None,force=False):
        #判断是否从文件读取配置
        if not self.__config or force:
            config_file = self.__plugin_path + 'config.json'
            if not os.path.exists(config_file): return None
            f_body = public.ReadFile(config_file)
            if not f_body: return None
            self.__config = json.loads(f_body)

        #取指定配置项
        if key:
            if key in self.__config: return self.__config[key]
            return None
        return self.__config


    #设置配置项(插件自身的配置文件)
    #@param key 要被修改或添加的配置项[可选]
    #@param value 配置值[可选]
    def __set_config(self,key=None,value=None):
        #是否需要初始化配置项
        if not self.__config: self.__config = {}

        #是否需要设置配置值
        if key:
            self.__config[key] = value

        #写入到配置文件
        config_file = self.__plugin_path + 'config.json'
        public.WriteFile(config_file,json.dumps(self.__config))
        return True
if __name__ == "__main__":
    type = sys.argv[1]
    path = sys.argv[2]
    hashname = sys.argv[3]
    files = sys.argv[4].strip('|').split("|")
    dirs = sys.argv[5].strip('|').split("|")
    send = sys.argv[6]
    os.chdir("/www/server/panel")
    import sys
    sys.path.append('class')
    import public
    aa = hash_pk_main()
    print('开始扫描对比')
    start_time=time.time()

    if type == 'site':
        localtime = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
        aa.files_hash(path,hashname)
        data = aa.send_san_dir(path,files,dirs,send)
        if len(data['add']) >= 1 or len(data['del']) >= 1 or len(data['edit']) >= 1:
            if len(data['add']) >= 1:
                public.WriteLog('宝塔文件效验完成！', '效验%s站点查到如下增加异常%s' % (path, data['add']))
            if len(data['del']) >= 1:
                public.WriteLog('宝塔文件效验完成！', '效验%s站点查到如下增加异常%s' % (path, data['del']))
            if len(data['edit']) >= 1:
                public.WriteLog('宝塔文件效验完成！', '效验%s站点查到如下增加异常%s' % (path, data['edit']))
            print('【%s】 效验完成！ 本次扫描耗时%s秒，发现%s个异常。' % (localtime,int(time.time() - start_time),len(data['add'])+len(data['del'])+len(data['edit'])))
        else:
            print('【%s】 效验完成！ 本次扫描耗时%s秒，未发现存在异常。' % (localtime, int(time.time() - start_time)))

        