
//定义窗口尺寸
$('.layui-layer-page').css({ 'width': '800px' });

//左测菜单切换效果
$(".bt-w-menu p").click(function () {
    $(this).addClass('bgw').siblings().removeClass('bgw')
});

var hash_pk = {
    bind: function () {
        var _this = this;
        var sitename = $('#sitename').text();
        $('.add_backup').unbind().click(function (e) {
            _this.set_site_hash(function (res) {
                if (typeof res == 'string') {
                    layer.msg('创建成功', { icon: 1 });
                }
            }, sitename);
        });

    },
    get_sites: function (p) {
        if (p == undefined) p = 1;
        request_plugin('hash_pk', 'get_sites', { p: p, callback: 'hash_pk.get_sites' }, function (res) {
            var site_body = '';
            for (var i = 0; i < res.data.length; i++) {
                site_body += '<tr><td>' + res.data[i].name + '</td><td>' + res.data[i].path + '</td><td><a class="btlink" onclick="hash_pk.hash_main(0,\'' +
                    res.data[i].name + '\')">效验</a>|<a class="btlink" onclick="hash_pk.get_list(\'' + res.data[i].name + '\')">列表</a></td></tr>'
            }

            var my_body = '<div class="hash_pk-table"><div class="divtable">'
                + '<table class="table table-hover">'
                + '<thead>'
                + '<tr><th width="150">站点名</th><th>站点路径</th><th>操作</th></tr>'
                + '</thead>'
                + '<tbody>' + site_body + '</tbody>'
                + '</table>'
                + '</div><div class="page" style="margin-top:15px">' + res.page + '</div></div>';

            $('.plugin_body').html(my_body);
        });
    },
    hash_main: function (type, sitename) {
        var url = '';
        var site_hash = '';
        if (type != 0) {
            site_hash = $("select[name='site_hash']").val();
        }
        $.post('/plugin?action=a&name=hash_pk&s=hash_main', { type: type, sitename: sitename, site_hash: site_hash }, function (res) {

            var zoneList = '';
            for (var i = 0; i < res.hashlist.length; i++) {
                zoneList += '<option value="' + res.hashlist[i].filename + '" >' + res.hashlist[i].filename + '</option>'
            }
            var my_body = '<div class="hash_pk-table"><div class="divtable mt10 relative"> 选择效验hash包:<select class="bt-input-text" name="site_hash">' +

                zoneList + '</select><input type="button"  class="btn btn-success btn-sm ml0 mlr15 add_backup"onclick="hash_pk.hash_main(1,\'' + sitename + '\')" value="开始效验">' +
                '</div><div class="log_body" >' +
                '<div class="log_edit_body" ></div>' +
                '<div class="log_add_body" ></div>' +
                '<div class="log_del_body" ></div>' +
                '</div></div>'

            $('.plugin_body').html(my_body);

            if (res.edit.length) {
                var editList = '';
                for (var i = 0; i < res.edit.length; i++) {
                    editList += '<tr><td>' + res.edit[i] + '</td><td style="text-align:right;"><a href="/download?filename=' + res.path + res.add[i] +
                        '" class="btlink">下载</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a class="btlink" onclick="openEditorView(0,\'' + res.path +
                        res.edit[i] + '\')" data-name="' + res.edit[i] + '">查看</a></td></tr>';
                }
            } else if (res.edit.length == 0) {
                editList = '<tr ><td colspan="4">当前没有被修改文件</td></tr>'
            } else {
                layer.msg('获取hash列表失败，请重新获取...');
            }
            var edittable = '<table class="table table-hover" width="100%" cellspacing="0" cellpediting="0" border="0">'
                + '<thead>'
                + '<tr><th>被修改文件</th><th style="text-align:right;"> 操作</th></tr>'
                + '</thead>'
                + '<tbody>' + editList + '</tbody>'
                + '</table>';
            $('.log_edit_body').html(edittable);
            if (res.add.length) {
                var addList = '';
                for (var i = 0; i < res.add.length; i++) {
                    addList += '<tr><td>' + res.add[i] + '</td><td style="text-align:right;"><a href="/download?filename=' + res.path + res.add[i] + '" class="btlink">下载</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a class="btlink" onclick="openEditorView(0,\'' + res.path + res.add[i] + '\')" data-name="' + res.add[i] + '">查看</a></td></tr>';
                }
            } else if (res.add.length == 0) {
                addList = '<tr ><td colspan="4">当前没有新增加文件</td></tr>'
            } else {
                layer.msg('获取hash列表失败，请重新获取...');
            }
            var addtable = '<table class="table table-hover" width="100%" cellspacing="0" cellpadding="0" border="0">'
                + '<thead>'
                + '<tr><th>新增文件</th><th style="text-align:right;"> 操作</th></tr>'
                + '</thead>'
                + '<tbody>' + addList + '</tbody>'
                + '</table>';
            $('.log_add_body').html(addtable);

            if (res.del.length) {
                var delList = '';
                for (var i = 0; i < res.del.length; i++) {
                    delList += '<tr><td>' + res.del[i] + '</td><td style="text-align:right;"><a href="#" class="btlink">下载</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a class="btlink" onclick="#" data-name="' + res.del[i] + '">查看</a></td></tr>';
                }
            } else if (res.del.length == 0) {
                delList = '<tr ><td colspan="4">当前没有被删除文件</td></tr>'
            } else {
                layer.msg('获取hash列表失败，请重新获取...');
            }
            var deltable = '<table class="table table-hover" width="100%" cellspacing="0" cellpdeling="0" border="0">'
                + '<thead>'
                + '<tr><th>被删除文件</th><th style="text-align:right;"> 操作</th></tr>'
                + '</thead>'
                + '<tbody>' + delList + '</tbody>'
                + '</table>';
            $('.log_del_body').html(deltable);


        });

    },
    get_list: function (sitename) {
        var load = layer.load();
        var sitename = sitename;
        $.post('/plugin?action=a&name=hash_pk&s=GetList', { sitename: sitename }, function (res) {
            layer.close(load);
            if (res.length) {
                var conter = '';
                for (var i = 0; i < res.length; i++) {
                    conter += '<tr><td>' + res[i].filename + '</td><td>' + res[i].size + '</td><td>' + getLocalTime(res[i].time) + '</td><td style="text-align:right;"><a href="' + res[i].download + '" class="btlink">下载</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a class="btlink" onclick="hash_pk.del_list(0,\'' + res[i].filename + '\',\'' + res[i].sitename + '\')" data-name="' + res[i].filename + '">删除</a></td></tr>'
                }
            } else if (res.length == 0) {
                conter = '<tr ><td colspan="4">当前没有数据</td></tr>'
            } else {
                layer.msg('获取hash列表失败，请重新获取...');
            }
            var my_body = '<div class="hash_pk-table">' +
                ' <input type="button"  class="btn btn-success btn-sm ml0 mlr15 add_backup"onclick="hash_pk.set_site_hash(\'' + sitename + '\')" value="创建hash文件"> ' +
                '<input type="button"  class="btn btn-success btn-sm ml0 mlr15 add_backup"onclick="hash_pk.update_backup(\'' + sitename + '\')" value="上传本地hash文件">' +
                '站点:' + sitename +
                // ' <button class="btn btn-success btn-sm update_backup_event">本地文件恢复</button>'+
                '<div class="divtable mt10 relative">' +
                '<table class="table table-hover" width="100%" cellspacing="0" cellpadding="0" border="0">'
                + '<thead>'
                + '<tr><th>文件名称</th><th>文件大小</th><th> 创建时间</th><th style="text-align:right;"> 操作</th></tr>'
                + '</thead>'
                + '<tbody>' + conter + '</tbody>'
                + '</table>'
                + '</div></div>';
            $('.plugin_body').html(my_body);

        });
    },
    set_site_hash: function (sitename) {
        var _this = this;
        var confirm = layer.confirm('是否创建该<a href="javascript:;" class="btlink">&nbsp;[' + sitename + ']</a>&nbsp; ', { title: '警告', btn: ['确定', '取消'], closeBtn: 2 }, function () {
            $.post('/plugin?action=a&name=hash_pk&s=get_hash', { sitename: sitename }, function (res) {
                layer.msg(res.msg, { icon: res.status ? 1 : 0 });
                _this.get_list(sitename)
            });
        }, function () {
            layer.close(confirm);
        });
    },
    // 上传导入本地文件
    update_backup: function (sitename) {
        var _this = this;
        var update_layer = layer.open({
            type: 1,
            closeBtn: 2,
            title: lan.files.up_title + '&nbsp;[仅支持hash格式上传]&nbsp;',
            area: ['500px', '500px'],
            shadeClose: false,
            content: '<div class="fileUploadDiv"><input type="hidden" id="input-val" value="/www/server/panel/backup/hash_pk/' + sitename + '" />\
                                <input type="file" id="file_input" autocomplete="off" accept=".hash" />\
                                <button type="button"  id="opt" autocomplete="off">'+ lan.files.up_add + '</button>\
                                <button type="button" id="up" autocomplete="off" >'+ lan.files.up_start + '</button>\
                                <span id="totalProgress" style="position: absolute;top: 7px;right: 147px;"></span>\
                                <span style="float:right;margin-top: 9px;">\
                                <font>'+ lan.files.up_coding + ':</font>\
                                <select id="fileCodeing" >\
                                    <option value="byte">'+ lan.files.up_bin + '</option>\
                                </select>\
                                </span>\
                                <button type="button" id="filesClose" autocomplete="off" onClick="" >'+ lan.public.close + '</button>\
                                <ul id="up_box"></ul></div>'
            // ,cancel:function(index, layero){ 
            //         _this.decompress_import();
            //     }
        });
        UploadStart(true);
        var upbox = setInterval(function () {
            if ($("#up_box li").eq(0).find('em').html() == "已上传成功") {
                clearInterval(upbox);
                layer.close(update_layer);
            }
        }, 100);
        $('#filesClose').click(function (e) {
            layer.close(update_layer);
            clearInterval(upbox);
        });
    },
    del_list: function (type, filename, sitename) {
        var _this = this;
        var confirm = layer.confirm('是否删除该<a href="javascript:;" class="btlink">&nbsp;[' + filename + ']</a>&nbsp;该备份文件? ', { title: '警告', btn: ['确定', '取消'], icon: 0, closeBtn: 2 }, function () {
            $.post('/plugin?action=a&name=hash_pk&s=DelFile', { filename: filename, sitename: sitename }, function (res) {
                layer.msg(res.msg, { icon: res.status ? 1 : 0 });
                type == 0 ? _this.get_list(sitename) : _this.get_Import_list()
            });
        }, function () {
            layer.close(confirm);
        });
    },
    filter_file: function (type) {
        var file = '';
        var dir = '';
        var status = '';
        if (type == 0) {
            file = $('#file').val();
            dir = $('#dir').val();
            status = $('#status')[0].checked
        }
        $.post('/plugin?action=a&name=hash_pk&s=set_filter_file', { type: type, status: status, file: file, dir: dir }, function (res) {

            var my_body = '<div class="hash_pk-table"><input type="checkbox" class="status" id="status" name="status" checked="checked"><label class="mr20" for="status" style="font-weight:normal">开启文件过滤</label><div class="divtable">' +
                '<p><span>过滤文件后缀</span>:<input class="bt-input-text" id="file" type="text" value="' + res.file + '" style="width:240px"/></p>' +
                '<p><span>过滤文件目录</span>:<input class="bt-input-text" id="dir" type="text" value="' + res.dir + '" style="width:240px" /></p> ' +
                '</div>' +
                '<input type="button"  class="btn btn-success btn-sm ml0 mlr15 add_backup"onclick="hash_pk.filter_file(0)" value="保存">' +
                '<ul class="help-info-text c7 mtb15">' +
                '<li>过滤的文件和目录不会再结果中显示</li>' +
                '<li>过滤文件后缀添加，输入后缀如.js，多个后缀使用|进行分割</li>' +
                '<li>过滤文件目录，输入目录名称如upload，多个目录使用|进行分割</li>' +
                '</ul>' +
                '</div>';
            if (type == 0) {
                layer.msg('修改成功', { icon: 1 });
            }
            $('.plugin_body').html(my_body);
            if (res.status == 'true') {
                $('#status').attr('checked', true)
            } else {
                $('#status').attr('checked', false)
            }

        });
    },
    files_main: function (type) {
        var path1 = '';
        var path2 = '';
        if (type == 0) {
            path1 = $('#path1').val();
            path2 = $('#path2').val();
            if (path1 == '') {
                layer.msg('效验目录没有选择', { icon: 2 });
                return false;
            }
            if (path2 == '') {
                layer.msg('参考目录没有选择', { icon: 2 });
                return false;
            }
        }
        $.post('/plugin?action=a&name=hash_pk&s=files_main', { type: type, path1: path1, path2: path2 }, function (res) {

            var my_body = '<div class="hash_pk-table"><div class="divtable">' +
                '<input class="bt-input-text mr5" id="path1" name="mountpath" type="text" value="" style="width:140px" placeholder="效验目录" />' +
                '<span class="glyphicon glyphicon-folder-open cursor" onclick="ChangePath(\'path1\')" style="margin-right: 18px;"></span>' +
                '<input class="bt-input-text mr5" id="path2" name="mountpath" type="text" value="" style="width:140px" placeholder="参考目录" />' +
                '<span class="glyphicon glyphicon-folder-open cursor" onclick="ChangePath(\'path2\')" style="margin-right: 18px;"></span>' +
                '<input type="button"  class="btn btn-success btn-sm ml0 mlr15 add_backup"onclick="hash_pk.files_main(0)" value="开始效验">' +
                '</div><div class="log_body" >' +
                '<div class="log_edit_body" ></div>' +
                '<div class="log_add_body" ></div>' +
                '<div class="log_del_body" ></div>' +
                '</div>' +
                '<ul class="help-info-text c7 mtb15">' +
                '<li>效验目录,需要检查的目录</li>' +
                '<li>参考目录,作为模板的目录</li>' +
                '</ul>' +
                '</div>';

            $('.plugin_body').html(my_body);
            if (res.edit.length) {
                var editList = '';
                for (var i = 0; i < res.edit.length; i++) {
                    editList += '<tr><td>' + res.edit[i] + '</td><td style="text-align:right;"><a href="/download?filename=' + res.path1 + res.edit[i] +
                        '" class="btlink">下载</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a class="btlink" onclick="openEditorView(0,\'' + res.path1 +
                        res.edit[i] + '\')" data-name="' + res.edit[i] + '">查看</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href="/download?filename=' + res.path2 + res.edit[i] + '" class="btlink">原文件下载</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a class="btlink" onclick="openEditorView(0,\'' + res.path2 + res.edit[i] + '\')" data-name="' + res.edit[i] + '">原文件查看</a></td></tr>';
                }
            } else if (res.edit.length == 0) {
                editList = '<tr ><td colspan="4">当前没有被修改文件</td></tr>'
            } else {
                layer.msg('获取hash列表失败，请重新获取...');
            }
            var edittable = '<table class="table table-hover" width="100%" cellspacing="0" cellpediting="0" border="0">'
                + '<thead>'
                + '<tr><th>被修改文件</th><th style="text-align:right;"> 操作</th></tr>'
                + '</thead>'
                + '<tbody>' + editList + '</tbody>'
                + '</table>';
            $('.log_edit_body').html(edittable);
            if (res.add.length) {
                var addList = '';
                for (var i = 0; i < res.add.length; i++) {
                    addList += '<tr><td>' + res.add[i] + '</td><td style="text-align:right;"><a href="/download?filename=' + res.path1 + res.add[i] + '" class="btlink">下载</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a class="btlink" onclick="openEditorView(0,\'' + res.path1 + res.add[i] + '\')" data-name="' + res.add[i] + '">查看</a></td></tr>';
                }
            } else if (res.add.length == 0) {
                addList = '<tr ><td colspan="4">当前没有新增加文件</td></tr>'
            } else {
                layer.msg('获取hash列表失败，请重新获取...');
            }
            var addtable = '<table class="table table-hover" width="100%" cellspacing="0" cellpadding="0" border="0">'
                + '<thead>'
                + '<tr><th>新增文件</th><th style="text-align:right;"> 操作</th></tr>'
                + '</thead>'
                + '<tbody>' + addList + '</tbody>'
                + '</table>';
            $('.log_add_body').html(addtable);

            if (res.del.length) {
                var delList = '';
                for (var i = 0; i < res.del.length; i++) {
                    delList += '<tr><td>' + res.del[i] + '</td><td style="text-align:right;"><a href="/download?filename=' + res.path2 + res.del[i] + '" class="btlink">下载</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a class="btlink" onclick="openEditorView(0,\'' + res.path2 + res.del[i] + '\')" data-name="' + res.del[i] + '">查看</a></td></tr>';
                }
            } else if (res.del.length == 0) {
                delList = '<tr ><td colspan="4">当前没有被删除文件</td></tr>'
            } else {
                layer.msg('获取hash列表失败，请重新获取...');
            }
            var deltable = '<table class="table table-hover" width="100%" cellspacing="0" cellpdeling="0" border="0">'
                + '<thead>'
                + '<tr><th>被删除文件</th><th style="text-align:right;"> 操作</th></tr>'
                + '</thead>'
                + '<tbody>' + delList + '</tbody>'
                + '</table>';
            $('.log_del_body').html(deltable);

        });
    },
    Monit_task: function () {
        $.post('/plugin?action=a&name=hash_pk&s=Monit_task', function (res) {
            var siteList = '';
            for (var i = 0; i < res.site_list.length; i++) {
                siteList += '<option value="' + res.site_list[i].name + '" >' + res.site_list[i].name + '</option>'
            }
            var my_body = '<div class="hash_pk-table"><div class="divtable mt10 relative plan planname "><span class="typename" style="width:60px">站点:</span><select class="bt-input-text" id="site_name" name="site_name">' +

                siteList + '</select></div><div class="site_hash_list"></div><div class="plan" height:150px >' +
                '<p><span class="typename" style="width:60px">后缀</span>:<input class="bt-input-text" id="file" type="text" value="" style="width:240px"/> ps:不监控的文件后缀</p>'+
                '<p><span class="typename" style="width:60px" >目录</span>:<input class="bt-input-text" id="dir" type="text" value="" style="width:240px" /> ps:不监控的文件目录</p> '+
                '<div class="textname pull-left mr20" style=" font-size: 14px;">消息通道</div><div class="dropdown planBackupTo pull-left mr20 message_start"></div>' +
                '</div>' +
                '<div class="date_body clearfix plan" style="height:60px;padding: 10px 0px;" ></div>' +
                '<div><input type="button"  class="btn btn-success btn-sm ml0 mlr15 add_backup plan-submit"onclick="planAdd()" value="添加计划任务"></div>' +
                '</div>'

            $('.plugin_body').html(my_body);

            $('#site_name').change(function () {
                $(this).css("background-color", "#FFFFCC");
                sitename = $("select[name='site_name']").val();
                $.post('/plugin?action=a&name=hash_pk&s=Monit_task', { sitename: sitename }, function (res) {
                    var hash_list = '';
                    for (var i = 0; i < res.hash_list.length; i++) {
                        hash_list += '<option value="' + res.hash_list[i].filename + '" >' + res.hash_list[i].filename + '</option>'
                    }
                    var my_body = '<div class="divtable mt10 relative plan"><span class="typename" style="width:60px">hash:</span>' +
                        '<select class="bt-input-text" id="hash_name" name="hash_name">' + hash_list + '</select></div>'

                    $('.site_hash_list').html(my_body);


                })
            });
            var date_body = '<div class="clearfix plan">' +
                '<span class="typename c4 pull-left f14 text-right mr20" style="width:60px;">执行周期</span>' +
                '<div class="dropdown plancycle pull-left mr20">' +
                '<button class="btn btn-default dropdown-toggle" type="button" id="cycle" data-toggle="dropdown" style="width:94px">' +
                '<b val="week">每星期</b><span class="caret"></span></button>' +
                '<ul class="dropdown-menu" role="menu" aria-labelledby="cycle">' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="day">每天</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="day-n">N天</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="hour">每小时</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="hour-n">N小时</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="minute-n">N分钟</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="week">每星期</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="month">每月</a></li>' +
                '</ul></div>' +
                '<div id="ptime" class="pull-left">' +
                '<div class="dropdown planweek pull-left mr20">' +
                '<button class="btn btn-default dropdown-toggle" type="button" id="excode" data-toggle="dropdown"><b val="1">周一</b> <span class="caret"></span></button>' +
                '<ul class="dropdown-menu" role="menu" aria-labelledby="excode">' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="1">周一</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="2">周二</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="3">周三</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="4">周四</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="5">周五</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="6">周六</a></li>' +
                '<li><a role="menuitem" tabindex="-1" href="javascript:;" value="0">周天</a></li>' +
                '</ul></div>' +
                '<div class="plan_hms pull-left mr20 bt-input-text"> <span><input type="number" name="hour" value="1" maxlength="2" max="23" min="0"></span> <span class="name">小时</span> </div>' +
                '<div class="plan_hms pull-left mr20 bt-input-text"> <span><input type="number" name="minute" value="30" maxlength="2" max="59" min="0"></span> <span class="name">分钟</span> </div>' +
                '</div>' +
                '<form id="set-Config" action="/crontab?action=AddCrontab" enctype="multipart/form-data" method="post" style="display: none;">\
                <input type="text" name="name" value="">\
                <input type="text" name="type" value="">\
                <input type="number" name="where1" value="">\
                <input type="number" name="hour" value="">\
                <input type="number" name="minute" value="">\
                <input type="text" name="week" value="">\
                <input type="text" name="sType" value="">\
                <textarea name="sBody"></textarea>\
                <input id="sFile" type="file" name="sFile" value="">\
                <input id="sName" type="text" name="sName" value="">\
                <input id="backupTo" type="text" name="backupTo" value="localhost">\
                <input type="number" name="save" value="">\
                <input type="submit">\
            </form>'+
                '</div>'
            $('.date_body').html(date_body);
            $(".dropdown ul li a").click(function () {
                var txt = $(this).text();
                var type = $(this).attr("value");
                $(this).parents(".dropdown").find("button b").text(txt).attr("val", type);
                dropdown(type);

            })
            message_channel_start();

        })

    },
    contact: function () {
        var my_body = '\
            如果有异常可以联系<br/>\
            个人微信号:qinzixiaobai<br/>\
            Email：liusqlf@function163.com<br/> \
            QQ：756610201<br/>\
            <p style="color:red"> 意见和建议：</p><a href="https://www.bt.cn/bbs/thread-58580-1-1.html">反馈地址</a>'


        $('.plugin_body').html(my_body);
    }
}

function request_plugin(plugin_name, function_name, args, callback, timeout) {
    if (!timeout) timeout = 3600;
    $.ajax({
        type: 'POST',
        url: '/plugin?action=a&s=' + function_name + '&name=' + plugin_name,
        data: args,
        timeout: timeout,
        success: function (res) {
            if (!callback) {
                layer.msg(res.msg, { icon: res.status ? 1 : 2 });
                return;
            }
            return callback(res);
        },
        error: function (ex) {
            if (!callback) {
                layer.msg('请求过程发现错误!', { icon: 2 });
                return;
            }
            return callback(ex);
        }
    });
}

//第一次打开窗口时调用

//表格头固定

// function scrollHandle (e){
//     var scrollTop = this.scrollTop;
//     //this.querySelector('thead').style.transform = 'translateY(' + scrollTop + 'px)';
//     $(this).find("thead").css({"transform":"translateY("+scrollTop+"px)","position":"relative","z-index":"1"});
// }
// 计划任务添加
function planAdd() {
    var name = '站点[' + $(".planname select[name='site_name']").val() + ']文件篡改监控';
    if (name == '') {
        $(".planname select[name='site_name']").focus();
        layer.msg(lan.crontab.add_task_empty, { icon: 2 });
        return;
    }
    $("#set-Config input[name='name']").val(name);

    var type = $(".plancycle").find("b").attr("val");
    $("#set-Config input[name='type']").val(type);

    var where1 = $("#ptime input[name='where1']").val();
    var is1;
    var is2 = 1;
    switch (type) {
        case 'day-n':
            is1 = 31;
            break;
        case 'hour-n':
            is1 = 23;
            break;
        case 'minute-n':
            is1 = 59;
            break;
        case 'month':
            is1 = 31;
            break;

    }

    if (where1 > is1 || where1 < is2) {
        $("#ptime input[name='where1']").focus();
        layer.msg(lan.public.input_err, { icon: 2 });
        return;
    }

    $("#set-Config input[name='where1']").val(where1);

    var hour = $("#ptime input[name='hour']").val();
    if (hour > 23 || hour < 0) {
        $("#ptime input[name='hour']").focus();
        layer.msg(lan.crontab.input_hour_err, { icon: 2 });
        return;
    }
    $("#set-Config input[name='hour']").val(hour);
    var minute = $("#ptime input[name='minute']").val();
    if (minute > 59 || minute < 0) {
        $("#ptime input[name='minute']").focus();
        layer.msg(lan.crontab.input_minute_err, { icon: 2 });
        return;
    }
    $("#set-Config input[name='minute']").val(minute);



    $("#set-Config input[name='week']").val($(".planweek").find("b").attr("val"));
    var sType = 'toShell';
    var sitename = $("select[name='site_name']").val();
    var hash_name = $("select[name='hash_name']").val();
    if (!hash_name) {
        layer.msg('站点hash包没有选择', { icon: 2 });
        return;
    }
    var files = $('#file').val();
    var dirs = $('#dir').val();
    var alert = $('.check_alert input[name="alert"]:checked ').val();
    var body = '/www/server/panel/pyenv/bin/python /www/server/panel/plugin/hash_pk/hash_pk_main.py site ' + sitename + ' ' + hash_name + '  "'+ files + '" "'+ dirs + '" ' + alert;
    var sBody = encodeURIComponent(body);

    if (sType == 'toFile') {
        if ($("#viewfile").val() == '') {
            layer.msg(lan.crontab.input_file_err, { icon: 2 });
            return;
        }
    } else {
        if (sBody == '' && sType == 'toShell') {
            $("#implement textarea[name='sBody']").focus();
            layer.msg(lan.crontab.input_script_err, { icon: 2 });
            return;
        }
    }
    var urladdress_1 = $("#urladdress_1").val();
    if (sType == 'toUrl') {
        if (!IsURL(urladdress_1)) {
            layer.msg(lan.crontab.input_url_err, { icon: 2 });
            $("implement textarea[name='urladdress_1']").focus();
            return;
        }
    }
    urladdress_1 = encodeURIComponent(urladdress_1);
    $("#set-Config input[name='sType']").val(sType);
    $("#set-Config textarea[name='sBody']").val(decodeURIComponent(sBody));

    if (sType == 'site' || sType == 'database' || sType == 'path') {
        var backupTo = $(".planBackupTo").find("b").attr("val");
        $("#backupTo").val(backupTo);
    }


    var sName = $("#sName").attr("val");

    $("#set-Config input[name='sName']").val(sName);
    layer.msg(lan.public.the_add, { icon: 16, time: 0, shade: [0.3, '#000'] });

    var urladdress_1 = $("#urladdress_1").val();
    var data = $("#set-Config").serialize() + '&sBody=' + sBody + '&urladdress=' + urladdress_1;

    if (data.indexOf('sType=path') > -1) {
        data = data.replace('&sName=&', '&sName=' + encodeURIComponent($('#inputPath').val()) + '&')
    } else if (data.indexOf('sType=webshell') > -1) {
        data = $("#set-Config").serialize() + '&urladdress=' + $(".message_start input:checked").val()
        data = data.replace('&sName=&', '&sName=' + encodeURIComponent($('#filePath').val()) + '&')
    }
    $.post('/crontab?action=AddCrontab', data, function (rdata) {
        //
        setTimeout(function () {
            layer.msg(rdata.msg + ' 请到计划任务中进行查看', { icon: rdata.status ? 1 : 2 });
        }, 1000)
    });
}

function dropdown(type) {

    $('#logs_tips').remove();
    $(".plan-submit").css({ "pointer-events": "auto", "background-color": "#20a53a", "color": "#fff" });
    switch (type) {
        case 'day':
            closeOpt();
            toHour();
            toMinute();
            break;
        case 'day-n':
            closeOpt();
            toWhere1(lan.crontab.day);
            toHour();
            toMinute();
            break;
        case 'hour':
            closeOpt();
            toMinute();
            break;
        case 'hour-n':
            closeOpt();
            toWhere1(lan.crontab.hour);
            toMinute();
            break;
        case 'minute-n':
            closeOpt();
            toWhere1(lan.crontab.minute);
            break;
        case 'week':
            closeOpt();
            toWeek();
            toHour();
            toMinute();
            break;
        case 'month':
            closeOpt();
            toWhere1(lan.crontab.sun);
            toHour();
            toMinute();
            break;
    }
}

//下拉菜单名称
function getselectname() {
    $(".dropdown ul li a").click(function () {
        var txt = $(this).text();
        var type = $(this).attr("value");
        $(this).parents(".dropdown").find("button b").text(txt).attr("val", type);
    });
}
//清理
function closeOpt() {
    $("#ptime").html('');
}
//星期
function toWeek() {
    var mBody = '<div class="dropdown planweek pull-left mr20">\
                      <button class="btn btn-default dropdown-toggle" type="button" id="excode" data-toggle="dropdown">\
                        <b val="1">'+ lan.crontab.TZZ1 + '</b> <span class="caret"></span>\
                      </button>\
                      <ul class="dropdown-menu" role="menu" aria-labelledby="excode">\
                        <li><a role="menuitem" tabindex="-1" href="javascript:;" value="1">'+ lan.crontab.TZZ1 + '</a></li>\
                        <li><a role="menuitem" tabindex="-1" href="javascript:;" value="2">'+ lan.crontab.TZZ2 + '</a></li>\
                        <li><a role="menuitem" tabindex="-1" href="javascript:;" value="3">'+ lan.crontab.TZZ3 + '</a></li>\
                        <li><a role="menuitem" tabindex="-1" href="javascript:;" value="4">'+ lan.crontab.TZZ4 + '</a></li>\
                        <li><a role="menuitem" tabindex="-1" href="javascript:;" value="5">'+ lan.crontab.TZZ5 + '</a></li>\
                        <li><a role="menuitem" tabindex="-1" href="javascript:;" value="6">'+ lan.crontab.TZZ6 + '</a></li>\
                        <li><a role="menuitem" tabindex="-1" href="javascript:;" value="0">'+ lan.crontab.TZZ7 + '</a></li>\
                      </ul>\
                    </div>';
    $("#ptime").html(mBody);
    getselectname()
}
//指定1
function toWhere1(ix) {
    var mBody = '<div class="plan_hms pull-left mr20 bt-input-text">\
                    <span><input type="number" name="where1" value="3" maxlength="2" max="31" min="0"></span>\
                    <span class="name">'+ ix + '</span>\
                    </div>';
    $("#ptime").append(mBody);
}
//小时
function toHour() {
    var mBody = '<div class="plan_hms pull-left mr20 bt-input-text">\
                    <span><input type="number" name="hour" value="1" maxlength="2" max="23" min="0"></span>\
                    <span class="name">'+ lan.crontab.hour + '</span>\
                    </div>';
    $("#ptime").append(mBody);
}

//分钟
function toMinute() {
    var mBody = '<div class="plan_hms pull-left mr20 bt-input-text">\
                    <span><input type="number" name="minute" value="30" maxlength="2" max="59" min="0"></span>\
                    <span class="name">'+ lan.crontab.minute + '</span>\
                    </div>';
    $("#ptime").append(mBody);

}
function message_channel_start() {
    $.post('/config?action=get_settings', function (res) {
        var wBody = "", s_mail = res.user_mail.user_name, s_ding = res.dingding.dingding
        if (!s_mail && !s_ding) {
            $(".plan-submit").css({ "pointer-events": "none", "background-color": "#e6e6e6", "color": "#333" });
            return $(".message_start").html('<span style="color:red;">未设置消息通道，请前往面板设置添加消息通道配置<a href="https://www.bt.cn/bbs/thread-42312-1-1.html" target="_blank" class="bt-ico-ask" style="cursor: pointer;">?</a></span>');
        }
        if (s_mail) {
            wBody = '<div class="check_alert" style="margin-right:20px;display: inline-block;">\
                <input id="mail" type="radio" name="alert" title="邮箱" value="mail" '+ (s_ding ? 'checked' : (s_mail ? 'checked' : '')) + '>\
                <label for="mail" style="font-weight: normal;font-size: 14px;margin-left: 6px;display: inline;">邮箱</label>\
            </div>'
        }
        if (s_ding) {
            wBody += '<div class="check_alert" style="display: inline-block;">\
                <input id="dingding" type="radio" name="alert" title="钉钉" value="dingding" '+ (s_mail ? '' : 'checked') + '>\
                <label for="dingding" style="font-weight: normal;font-size: 14px;margin-left: 6px;display: inline;">钉钉</label>\
            </div>'
        }
        $(".message_start").html(wBody);
    })
}